// MainFrm.h : interface of the CMainFrame class
//


#pragma once

#include "MyView.h"
#include "MyData.h"
#include "MyToolBar.h"
#include "MySelectCharPopUp.h"
#include "MyStatusBar.h"

#include "Resource.h"

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame(){};
	virtual ~CMainFrame(){};


public:

	CMyView    m_MyView;
	CMyData	   m_MyData;

// Generated message map functions

	CMyToolBar     m_MyToolBar;
	CMySelectCharPopUp* m_MySelectCharPopUp;

	TBBUTTON b1;

	CMyStatusBar   m_MyStatusBar;
/***************************************************************************/
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/***************************************************************************/

protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct)
	{
		CFrameWnd::OnCreate(lpCreateStruct);
		
		m_MyToolBar.CreateEx(this, TBSTYLE_FLAT|TBSTYLE_LIST, WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_SIZE_DYNAMIC, CRect(0,0,5,5),
			ID_MYTOOLBAR);
		m_MyToolBar.LoadToolBar(IDR_TOOLBAR);

	

		LPCTSTR myClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW, 
			::LoadCursor(NULL, IDC_ARROW), (HBRUSH)::GetStockObject(WHITE_BRUSH), NULL);

		m_MyView.SetData( &m_MyData );

		m_MyView.Create(myClass,0,WS_CHILD | WS_VISIBLE,CRect(0, 0, 300, 100),
						this ,444,0); // ??AFX_IDW_PANE_FIRST

		
		// Set Control Bar Information
		m_MyToolBar.SetButtonText(0, "Save Art");
		m_MyToolBar.SetButtonText(1, "Select Character");

		m_MyToolBar.GetToolBarCtrl().SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS);
		m_MyToolBar.SetButtonStyle(1, m_MyToolBar.GetButtonStyle(1)|TBSTYLE_DROPDOWN);

		// Add popdown dialog to the Control Bar
		m_MySelectCharPopUp = new CMySelectCharPopUp(this);

		// Init our Status Bar on the bottom.
		m_MyStatusBar.Create(this, WS_CHILD|WS_VISIBLE|CBRS_BOTTOM, ID_MYSTATUSBAR);
		return 0;
	}

protected:
	afx_msg void OnSize(UINT n, int cx, int cy)
	{
		CFrameWnd::OnSize(n, cx, cy);
		
		CRect rect, rr;
		m_MyToolBar.GetClientRect(rect);
		m_MyStatusBar.GetClientRect(rr);

		m_MyView.MoveWindow(CRect(0,rect.bottom+3, cx, cy-rr.bottom), TRUE);
		
	}


	afx_msg void CmSave()
	{
		CFileDialog f(FALSE, "*.txt", "*.*", OFN_OVERWRITEPROMPT, "Text Files |*.txt|All Files|*.*||", this);
		
		UINT bb = (UINT)f.DoModal();

		if( bb == IDOK)
		{
			char buf[256] = {'\0'};
			strcpy(buf, f.GetFileName());

			//MessageBox(buf);
			m_MyData.CmSave( buf );	
		}

	}
	afx_msg void CmOpen()
	{
		CFileDialog f(TRUE, "*.txt", "*.*", OFN_OVERWRITEPROMPT, "Text Files |*.txt|All Files|*.*||", this);
		
		UINT bb = (UINT)f.DoModal();

		if( bb == IDOK)
		{
			char buf[256] = {'\0'};
			strcpy(buf, f.GetFileName());

			//MessageBox(buf);
			m_MyData.CmOpen( buf );	
		}
		Invalidate();
	}

	afx_msg void CmReset()
	{
		m_MyData.ClearArray(' ');
		Invalidate(TRUE);
	}
	afx_msg void CmSelectChar()
	{
	}

	afx_msg void OnNcMouseMove(UINT nHitTest,CPoint point )
	{
		CFrameWnd::OnNcMouseMove(nHitTest, point);

		m_MyView.OnNcMouseMove(nHitTest, point);	
	}

	afx_msg void OnToolbarDropDown(NMHDR* p, LRESULT* l)
	{
		NMTOOLBAR* pTB = (NMTOOLBAR*)p;

		// First things first!...load and display our pop up menu
		
		static bool bSelected = false;
		if( !m_MySelectCharPopUp->bVisible )
		{
			CRect rc;
			m_MyToolBar.SendMessage(TB_GETRECT, pTB->iItem, (LPARAM)&rc);
			m_MyToolBar.ClientToScreen(&rc);

			//menu.TrackPopupMenu(TPM_LEFTALIGN| TPM_LEFTBUTTON | TPM_VERTICAL,
			//	rc.left, rc.bottom, this); 
			CRect rectPopup;
			m_MySelectCharPopUp->GetWindowRect(&rectPopup);

			m_MySelectCharPopUp->ShowWindow(SW_SHOW);
			m_MySelectCharPopUp->SetWindowPos(NULL, rc.left, rc.bottom, 
				rectPopup.right-rectPopup.left, rectPopup.bottom-rectPopup.top, 0); 
			bSelected = true;
			m_MySelectCharPopUp->bVisible = true;
		}
		else
		{
			m_MySelectCharPopUp->ShowWindow(SW_HIDE);
			bSelected = false;
			m_MySelectCharPopUp->bVisible = false;
		}
		
	}

	afx_msg void OnNcLButtonDown( UINT i, CPoint p)
	{
		//m_MySelectCharPopUp->OnNcLButtonDown( i, p );

		CFrameWnd::OnNcLButtonDown(i, p);
	}
	afx_msg LRESULT CmHideCharPopUp(WPARAM w, LPARAM l)
	{
	
			m_MySelectCharPopUp->ShowWindow(SW_HIDE);
			m_MySelectCharPopUp->bVisible = false;
			
			return 1;
	}

	afx_msg LRESULT CmCharChange(WPARAM w, LPARAM l)
	{
		
		m_MyData.cSelectedChar = ((char*)w)[0];

		CString s;
		s.Format(" Currently Selected String : %c ", m_MyData.cSelectedChar );

		m_MyStatusBar.SetPaneText(1, s);

		m_MySelectCharPopUp->ShowWindow(SW_HIDE);
		m_MySelectCharPopUp->bVisible = false;

		return 1;
	}

	DECLARE_MESSAGE_MAP()
};


