#pragma once

#include "MyData.h"

class CMyView : public CWnd
{
public:
	int m_iClientWidth;
	int m_iClientHeight;

public:
	
	CMyView(void){ m_pMyData = NULL;};
	virtual ~CMyView(void){};

	CMyData *m_pMyData;
	void SetData(CMyData* p)
	{
		m_pMyData = p;
	}
	CMyData* GetData()
	{
		return m_pMyData;
	}

	
	afx_msg int OnCreate(LPCREATESTRUCT lp)
	{
		CWnd::OnCreate(lp);

		TEXTMETRIC tm;

		CClientDC* ptrdc = new CClientDC(this);
		ptrdc->GetTextMetrics(&tm);
		delete ptrdc;

		GetData()->avg_char_width   = tm.tmAveCharWidth;
		GetData()->avg_char_height  = tm.tmHeight + tm.tmExternalLeading;
		GetData()->avg_caps_width   = (tm.tmPitchAndFamily & 1 ? 3:2 ) * GetData()->avg_char_width / 2;

		GetData()->avg_char_width   +=2;
		GetData()->avg_char_height  +=2;
		GetData()->avg_caps_width   +=2;

		GetData()->cSelectedChar = 'S';
		return 0;
	}

/***************************************************************************/
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/***************************************************************************/

	void DrawGrid()
	{
		int charH = GetData()->avg_char_height;
		int charW = GetData()->avg_caps_width;

		CClientDC dc(this);
		
		for( int y=0; y<m_iClientHeight; y+=charH)
		{
			dc.MoveTo(0, y);
			dc.LineTo(m_iClientWidth, y );
		}

		for( int x=0; x<m_iClientWidth; x+=charW)
		{
			dc.MoveTo(x, 0);
			dc.LineTo(x, m_iClientHeight );
		}
	}

	void DrawCharacters()
	{
		int charH = GetData()->avg_char_height;
		int charW = GetData()->avg_caps_width;

		int w = m_iClientWidth/ charW;
		int h = m_iClientHeight /charH;

		CClientDC dc(this);

		if( (GetData()->Max_Array_Width) < (m_iClientWidth/charW) )
			w = (GetData()->Max_Array_Width - 1) ;

		if( GetData()->Max_Array_Height < (m_iClientHeight/charH) )
			h = (GetData()->Max_Array_Height)  ;


		for( int x=0; x<w; x++)
		{
			for( int y=0; y<h; y++)
			{
				//if( (x | y) >= 100 )
				//	break;

				dc.TextOut( x*charW +1, y*charH +1, &(GetData()->array[x][y]), 1);
			}
		}	
	}

protected:
	afx_msg void OnPaint()
	{
		Invert(-1,-1, 1, 1, false, true);

		CPaintDC dc(this);

		DrawGrid();
		
		DrawCharacters();

		Invert(-1,-1, 1, 1, true, true);
	}

	afx_msg void OnSize(UINT n, int cx, int cy)
	{
		m_iClientWidth  = cx;
		m_iClientHeight = cy;

		Invert(0,0, 5, 5, false, false);
		Invert(0,0, 5, 5, true, true);
	}

	afx_msg void OnLButtonDown(UINT nFlags,CPoint point)
	{
		CClientDC dc(this);

		int charH = GetData()->avg_char_height;
		int charW = GetData()->avg_caps_width;

		int x = point.x - (point.x % charW);
		int y = point.y - (point.y % charH);

		int array_pos_x = x/charW;
		int array_pos_y = y/charH;

		GetData()->array[array_pos_x][array_pos_y] = GetData()->cSelectedChar;

		Invert(-1,-1, 1, 1, true, true);

		InvalidateRect(CRect(x+1, y+1, x + charW, y + charH), TRUE);

		//Invert(0,0, 5, 5, false, false);

		

	}

	afx_msg void OnRButtonDown(UINT nFlags,CPoint point)
	{
		CClientDC dc(this);

		int charH = GetData()->avg_char_height;
		int charW = GetData()->avg_caps_width;

		int x = point.x - (point.x % charW);
		int y = point.y - (point.y % charH);

		int array_pos_x = x/charW;
		int array_pos_y = y/charH;

		GetData()->array[array_pos_x][array_pos_y] = ' ';

		Invert(-1,-1, 1, 1, true, true);

		InvalidateRect(CRect(x+1, y+1, x + charW, y + charH), TRUE);

	}

	afx_msg void OnLButtonUp(UINT nFlags,CPoint point)
	{
		Invert(-1,-1, 1, 1, false, false);
	}

	afx_msg void OnRButtonUp(UINT nFlags,CPoint point)
	{
		Invert(-1,-1, 1, 1, false, false);
	}

	afx_msg void Invert(int x_pos, int y_pos, int width, int height, bool remove = false, bool reset = false)
	{

		CClientDC dc(this);

		static bool bRemove = false;
		

		static int charH = 0;
		static int charW = 0;

		static int x = 0;
		static int y = 0;

		
		if (reset)
		{
			charH = height;
			charW = width;

			x = x_pos;
			y = y_pos;
		}
		
		if( bRemove != remove)
		{
			bRemove = remove;

		BitBlt(
				dc.m_hDC, // handle to destination DC
				x+1,  // x-coord of destination upper-left corner
				y+1,  // y-coord of destination upper-left corner
				charW,  // width of destination rectangle
				charH, // height of destination rectangle
				0,  // handle to source DC
				0,   // x-coordinate of source upper-left corner
				0,   // y-coordinate of source upper-left corner
				DSTINVERT // raster operation code
			);

		charH = height;
		charW = width;

		x = x_pos - (x_pos % charW);
		y = y_pos - (y_pos % charH);

		
		BitBlt(
				dc.m_hDC, // handle to destination DC
				x+1,  // x-coord of destination upper-left corner
				y+1,  // y-coord of destination upper-left corner
				charW,  // width of destination rectangle
				charH, // height of destination rectangle
				0,  // handle to source DC
				0,   // x-coordinate of source upper-left corner
				0,   // y-coordinate of source upper-left corner
				DSTINVERT  // raster operation code
			);
		
		}
	}

public:
	afx_msg void OnNcMouseMove(UINT nHitTest,CPoint point )
	{
		//ScreenToClient(&point);
		//if( point.x > m_iClientWidth )
		{
			Invert(-1,-1, 1, 1, false, false);
			Invert(-1,-1, 1, 1, true, false);

			
		}
	}

	afx_msg void OnMouseMove(UINT nFlags,CPoint point )
	{

		switch ( nFlags )
		{
		case MK_LBUTTON:
			{

				CClientDC dc(this);

				int charH = GetData()->avg_char_height;
				int charW = GetData()->avg_caps_width;

				int x = point.x - (point.x % charW);
				int y = point.y - (point.y % charH);

				int array_pos_x = x/charW;
				int array_pos_y = y/charH;

				GetData()->array[array_pos_x][array_pos_y] = GetData()->cSelectedChar;

				Invert(-1,-1, 1, 1, true, false);

				//InvalidateRect(CRect(x+1, y+1, x + charW-6, y + charH-6), TRUE);
				dc.FillRect( CRect(x+1, y+1, x + charW, y + charH), &CBrush(RGB(255,255,255)));
				dc.TextOut( array_pos_x*charW +1, array_pos_y*charH +1, &(GetData()->array[array_pos_x][array_pos_y]), 1);
				

				Invert(point.x,point.y, GetData()->avg_caps_width, GetData()->avg_char_height, false, false);

			}
			break;
		case MK_RBUTTON:
			{

			CClientDC dc(this);

			int charH = GetData()->avg_char_height;
			int charW = GetData()->avg_caps_width;

			int x = point.x - (point.x % charW);
			int y = point.y - (point.y % charH);

			int array_pos_x = x/charW;
			int array_pos_y = y/charH;

			GetData()->array[array_pos_x][array_pos_y] = ' ';

			Invert(-1,-1, 1, 1, true, false);

			dc.FillRect( CRect(x+1, y+1, x + charW, y + charH), &CBrush(RGB(255,255,255)));
			dc.TextOut( array_pos_x*charW +1, array_pos_y*charH +1, &(GetData()->array[array_pos_x][array_pos_y]), 1);

			Invert(point.x,point.y, GetData()->avg_caps_width, GetData()->avg_char_height, false, false);

		}
			break;
		default:

			Invert( point.x, point.y, GetData()->avg_caps_width, GetData()->avg_char_height, false);
			Invert( point.x, point.y, GetData()->avg_caps_width, GetData()->avg_char_height, true);
		}

	}


	DECLARE_MESSAGE_MAP()
};
